package com.miaozhen.mzanalytics_mybmw;

import android.app.Activity;
import android.content.Context;
import android.util.Log;

import androidx.annotation.NonNull;


import org.json.JSONObject;

import java.util.List;
import java.util.Map;

import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.embedding.engine.plugins.activity.ActivityAware;
import io.flutter.embedding.engine.plugins.activity.ActivityPluginBinding;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;

/**
 * MzanalyticsMybmwPlugin
 */
public class MzanalyticsMybmwPlugin implements FlutterPlugin, ActivityAware, MethodCallHandler {

    /// The MethodChannel that will the communication between Flutter and native Android
    ///
    /// This local reference serves to register the plugin with the Flutter Engine and unregister it
    /// when the Flutter Engine is detached from the Activity
    private MethodChannel channel;
    private static Context applicationContext;
    private  static  Activity applicationActivity;

    @Override
    public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
        channel = new MethodChannel(flutterPluginBinding.getFlutterEngine().getDartExecutor(), "mzanalytics_mybmw");
        channel.setMethodCallHandler(this);
        Log.i("wlt", "测试！！！！！！！！！！！！！！！！！！ ");
        applicationContext = flutterPluginBinding.getApplicationContext();
    }
    @Override
    public void onAttachedToActivity(@NonNull final ActivityPluginBinding binding) {
        applicationActivity  = binding.getActivity();

    }

    @Override
    public void onDetachedFromActivityForConfigChanges() {

    }

    @Override
    public void onReattachedToActivityForConfigChanges(@NonNull @org.jetbrains.annotations.NotNull ActivityPluginBinding binding) {

    }

    @Override
    public void onDetachedFromActivity() {

    }

    // This static function is optional and equivalent to onAttachedToEngine. It supports the old
    // pre-Flutter-1.12 Android projects. You are encouraged to continue supporting
    // plugin registration via this function while apps migrate to use the new Android APIs
    // post-flutter-1.12 via https://flutter.dev/go/android-project-migration.
    //
    // It is encouraged to share logic between onAttachedToEngine and registerWith to keep
    // them functionally equivalent. Only one of onAttachedToEngine or registerWith will be called
    // depending on the user's project. onAttachedToEngine or registerWith must both be defined
    // in the same class.
    @SuppressWarnings("deprecation")
    public static void registerWith(Registrar registrar) {
        final MethodChannel channel = new MethodChannel(registrar.messenger(), "mzanalytics_mybmw");
        channel.setMethodCallHandler(new MzanalyticsMybmwPlugin());
        Activity activity = registrar.activity();

        applicationContext = activity.getApplicationContext();
    }

    @Override
    public void onMethodCall(@NonNull MethodCall call, @NonNull Result result) {

        try {
            if (call.method.equals("initEvent")) {
                String appkey = (String) call.arguments;
                JSONObject baseObject = new JSONObject();
                baseObject.put("appkey",appkey);
                EventUtils.init(applicationContext,baseObject);
            } else if (call.method.equals("trackEvent")) {
                Map<String, String> map = (Map<String, String>) call.arguments;
                JSONObject baseObject = new JSONObject(map);
                EventUtils.trackEvent(applicationContext, baseObject);
            } else if (call.method.equals("trackPageView")) {
                Map<String, String> map = (Map<String, String>) call.arguments;
                JSONObject baseObject = new JSONObject(map);
                EventUtils.trackPageView(applicationContext, baseObject);
            } else if (call.method.equals("trackSiteCustomEvent")) {
                Map<String, String> map = (Map<String, String>) call.arguments;
                JSONObject baseObject = new JSONObject(map);
                EventUtils.trackSiteCustomEvent(applicationContext, baseObject);
            } else if (call.method.equals("trackPulse")) {
                EventUtils.trackPulse(applicationContext);
            } else if (call.method.equals("getCid")) {
                String cid = EventUtils.getCid(applicationContext);
                result.success(cid);
            } else if (call.method.equals("getOaid")) {
                String oaid = EventUtils.getOaid(applicationContext);
                result.success(oaid);
            } else if (call.method.equals("setCd")) {
                String key = call.argument("cd_key");
                String value = call.argument("cd_value");
                EventUtils.setCd(applicationContext, key, value);
            } else if (call.method.equals("setCm")) {
                String key = call.argument("cm_key");
                String value = call.argument("cm_value");
                EventUtils.setCm(applicationContext, key, value);
            } else if (call.method.equals("deleteCd")) {
                String key = call.argument("cd_key");
                EventUtils.deleteCd(applicationContext, key);
            } else if (call.method.equals("deleteCm")) {
                String key = call.argument("cm_key");
                EventUtils.deleteCm(applicationContext, key);
            } else if (call.method.equals("getCdAndCm")) {
                Map getCdAndCm = EventUtils.getCdAndCm(applicationContext);
                result.success(getCdAndCm);
            } else if (call.method.equals("isAutoTrackpage")) {
                boolean isAutoTrackpage = EventUtils.isAutoTrackpage(applicationContext);
                result.success(isAutoTrackpage);
            } else if (call.method.equals("getManualtrackpage")) {
                List blackList = EventUtils.getManualtrackpage(applicationContext);
                result.success(blackList);
            }else if (call.method.equals("handleOpenURL")){
                String linkUrl = (String) call.arguments;
                JSONObject baseObject = new JSONObject();
                baseObject.put("linUrl",linkUrl);
                EventUtils.deepLinkEvent(applicationContext, baseObject,applicationActivity);
            }else if (call.method.equals("setEnableLog")){
                boolean isDebug = call.argument("Enable");
                EventUtils.setLogEnabled(applicationContext, isDebug);
            }else if (call.method.equals("enableExceptionService")){
                boolean isDebug = call.argument("Enable");
                EventUtils.enableExceptionService(applicationContext,isDebug);
            }else if(call.method.equals("trackException")){
                //flutter 异常上报
                Map<String, String> map = (Map<String, String>) call.arguments;
                JSONObject baseObject = new JSONObject(map);
                EventUtils.trackException(applicationContext, baseObject);
            }else if(call.method.equals("MZNativeErrorTest")){
                String[] array= new String[3];
                array[10] = "100";
            }
            else {
                result.notImplemented();
            }
        } catch (Throwable e) {
            try {
                EventUtils.trackException(applicationContext, e);
            } catch (Throwable throwable) {
            }
        }
    }

    @Override
    public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
        channel.setMethodCallHandler(null);
    }


}
