import 'dart:async';
import 'dart:convert';
import 'dart:ffi';
import 'package:flutter/material.dart';
import 'package:mzanalytics_mybmw/mzanalytics_mybmw.dart';
import 'package:fluttertoast/fluttertoast.dart';
import 'dart:convert' as convert;

import 'package:mzanalytics_mybmw_example/FocusMonitoring.dart';

Future<void> main() async {
  runApp(CustomInputTestApp());
}

class CustomInputTestApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<CustomInputTestApp> {
  @override
  void initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: MainScaffold(),
    );
  }
}

class MainScaffold extends StatelessWidget {
  final TextEditingController appid_crontroller =
      new TextEditingController(text: "2814");
  final TextEditingController dt_crontroller = new TextEditingController(
      text:
          '{"dt": "首页", "CustomDimMetrics": {"cd1": "ID88888","cd2": "小明机器人","cm1": "1"  }}');

  final TextEditingController ev_crontroller = new TextEditingController(
      text:
          '{"ec": "领取奖励", "ea": "Click", "el": "任务箱领取奖励","CustomDimMetrics": {"cd3": "首次登陆任务箱",  "cm2": "2"  }}');
  final TextEditingController ca_crontroller = new TextEditingController(
      text:
          '{"CustomEvent": {    "caid": "14","cal1":"如果含有一个斜杠，记得输入两个，才能正确转义 ","cal2": "","cal3": "2685","cal4": "AFSStoreIndex-Campaigns2ndProduct-Click-1","cav1": "0" },"CustomDimMetrics": {"cd1": "0"} }');

  final TextEditingController cdcm_crontroller =
      new TextEditingController(text: '{"cd1":"123","cm1":"456"}');

  @override
  Widget build(BuildContext context) {
    return FocusMonitoring(
      child: Scaffold(
        appBar: AppBar(title: const Text(' CustomInput Test')),
        body: SingleChildScrollView(
          padding: EdgeInsets.all(16.0),
          child: Column(
            children: [
              const Center(child: Text('Trigger an action:\n')),
              TextField(
                controller: appid_crontroller,
                decoration: new InputDecoration(
                  hintText: "appid",
                ),
              ),
              ElevatedButton(
                key: Key("key5"),
                onPressed: () {
                  MzanalyticsMybmw.appid(appid_crontroller.text);
                },
                child: Text('激活'),
              ),
              TextField(
                controller: dt_crontroller,
                maxLines: 10,
                decoration: new InputDecoration(
                  hintText:
                      '{"dt": "首页", "CustomDimMetrics": {"cd1": "ID88888","cd2": "小明机器人","cm1": "1"  }}',
                ),
              ),
              ElevatedButton(
                key: Key("key1"),
                onPressed: () {
                  var jsonTxt1 =
                      '{ "name": "John Smith", "email": "john@example.com"}';
                  // print("jsonTxt1:" + jsonTxt1.toString());
                  var user = convert.jsonDecode(jsonTxt1);
                  print("user:" + user.toString());
                  print("开始转换1:");
                  var dt2 = convert.jsonDecode(jsonTxt1);
                  print("成功2:" + dt2.toString());
                  // print("dt_crontroller.text.toString():" +
                  //     dt_crontroller.text.toString());
                  // print("dt_crontroller.text2:" + dt_crontroller.text);
                  try {
                    print("开始转换3:");
                    var dt1 =
                        convert.jsonDecode(dt_crontroller.text.toString());
                    print("成功4:" + dt1.toString());
                    if ((dt1 is Map) == false) {
                      Fluttertoast.showToast(
                          msg: "不是有效的json字符串或缺少必要的字段，请参考示例格式填写。",
                          toastLength: Toast.LENGTH_SHORT,
                          gravity: ToastGravity.CENTER,
                          timeInSecForIosWeb: 1,
                          backgroundColor: Colors.black45,
                          textColor: Colors.white,
                          fontSize: 16.0);
                      return;
                    }
                    MzanalyticsMybmw.trackPageView(dt1);
                  } catch (e) {
                    print("失败");
                    Fluttertoast.showToast(
                        msg: "不是有效的json字符串，请参考示例格式填写。",
                        toastLength: Toast.LENGTH_SHORT,
                        gravity: ToastGravity.CENTER,
                        timeInSecForIosWeb: 1,
                        backgroundColor: Colors.black45,
                        textColor: Colors.white,
                        fontSize: 16.0);
                    return;
                  }
                },
                child: Text('页面'),
              ),
              TextField(
                controller: ev_crontroller,
                maxLines: 10,
                decoration: new InputDecoration(
                  hintText: "基础事件-eventAction",
                ),
              ),
              ElevatedButton(
                key: Key("key2"),
                onPressed: () {
                  try {
                    print("开始转换3:");
                    var ev = convert.jsonDecode(ev_crontroller.text.toString());

                    print("成功4:" + ev.toString());
                    if ((ev is Map) == false) {
                      Fluttertoast.showToast(
                          msg: "不是有效的json字符串或缺少必要的字段，请参考示例格式填写。",
                          toastLength: Toast.LENGTH_SHORT,
                          gravity: ToastGravity.CENTER,
                          timeInSecForIosWeb: 1,
                          backgroundColor: Colors.black45,
                          textColor: Colors.white,
                          fontSize: 16.0);
                      return;
                    }
                    MzanalyticsMybmw.trackEvent(ev);
                  } catch (e) {
                    print("失败");
                    Fluttertoast.showToast(
                        msg: "不是有效的json字符串，请参考示例格式填写。",
                        toastLength: Toast.LENGTH_SHORT,
                        gravity: ToastGravity.CENTER,
                        timeInSecForIosWeb: 1,
                        backgroundColor: Colors.black45,
                        textColor: Colors.white,
                        fontSize: 16.0);
                    return;
                  }
                },
                child: Text('基础'),
              ),
              TextField(
                controller: ca_crontroller,
                maxLines: 10,
                decoration: new InputDecoration(
                  hintText: "高级事件",
                ),
              ),
              ElevatedButton(
                key: Key("key3"),
                onPressed: () {
                  try {
                    print("开始转换3:");

                    var ca = convert.jsonDecode(ca_crontroller.text.toString());
                    print("成功4:" + ca.toString());
                    if ((ca is Map) == false) {
                      Fluttertoast.showToast(
                          msg: "不是有效的json字符串或缺少必要的字段，请参考示例格式填写。",
                          toastLength: Toast.LENGTH_SHORT,
                          gravity: ToastGravity.CENTER,
                          timeInSecForIosWeb: 1,
                          backgroundColor: Colors.black45,
                          textColor: Colors.white,
                          fontSize: 16.0);
                      return;
                    }
                    MzanalyticsMybmw.trackSiteCustomEvent(ca);
                  } catch (e) {
                    print("失败");
                    Fluttertoast.showToast(
                        msg: "不是有效的json字符串，请参考示例格式填写。",
                        toastLength: Toast.LENGTH_SHORT,
                        gravity: ToastGravity.CENTER,
                        timeInSecForIosWeb: 1,
                        backgroundColor: Colors.black45,
                        textColor: Colors.white,
                        fontSize: 16.0);
                    return;
                  }
                },
                child: Text('高级'),
              ),
              TextField(
                controller: cdcm_crontroller,
                maxLines: 10,
                decoration: new InputDecoration(
                  hintText: "全局cdcm",
                ),
              ),
              ElevatedButton(
                key: Key("key4"),
                onPressed: () {
                  try {
                    print("开始转换3:");
                    Map cmcd =
                        convert.jsonDecode(cdcm_crontroller.text.toString());

                    print("成功4:" + cmcd.toString());
                    if ((cmcd is Map) == false) {
                      Fluttertoast.showToast(
                          msg: "不是有效的json字符串或缺少必要的字段，请参考示例格式填写。",
                          toastLength: Toast.LENGTH_SHORT,
                          gravity: ToastGravity.CENTER,
                          timeInSecForIosWeb: 1,
                          backgroundColor: Colors.black45,
                          textColor: Colors.white,
                          fontSize: 16.0);
                      return;
                    }
                    for (var i = 0; i < cmcd.length; i++) {
                      if (cmcd["cd" + i.toString()] != null) {
                        MzanalyticsMybmw.setCd(
                            "cd" + i.toString(), cmcd["cd" + i.toString()]);
                      } else if (cmcd["cm" + i.toString()] != null) {
                        MzanalyticsMybmw.setCd(
                            "cm" + i.toString(), cmcd["cm" + i.toString()]);
                      }
                    }
                  } catch (e) {
                    print("失败");
                    Fluttertoast.showToast(
                        msg: "不是有效的json字符串，请参考示例格式填写。",
                        toastLength: Toast.LENGTH_SHORT,
                        gravity: ToastGravity.CENTER,
                        timeInSecForIosWeb: 1,
                        backgroundColor: Colors.black45,
                        textColor: Colors.white,
                        fontSize: 16.0);
                    return;
                  }
                },
                child: Text('全局cdcm'),
              ),
              Container(
                child: Row(
                  mainAxisAlignment: MainAxisAlignment.spaceEvenly, //元素与空白互相间隔
                  children: [],
                ),
              )
            ],
          ),
        ),
      ),
    );
  }
}
