import 'dart:async';

import 'package:flutter/material.dart';
import 'package:mzanalytics_mybmw/mzanalytics_mybmw.dart';
import 'package:mzanalytics_mybmw_example/FocusMonitoring.dart';

Future<void> main() async {
  runApp(InputTestApp());
}

class InputTestApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<InputTestApp> {
  @override
  void initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: MainScaffold(),
    );
  }
}

class MainScaffold extends StatelessWidget {
  final TextEditingController dt_crontroller = new TextEditingController();
  final TextEditingController ec_crontroller = new TextEditingController();
  final TextEditingController ea_crontroller = new TextEditingController();
  final TextEditingController et_crontroller = new TextEditingController();
  final TextEditingController ep_crontroller = new TextEditingController();

  final TextEditingController caid_crontroller = new TextEditingController();
  final TextEditingController calkey_crontroller = new TextEditingController();
  final TextEditingController calvalue_crontroller =
      new TextEditingController();

  final TextEditingController cavkey_crontroller = new TextEditingController();
  final TextEditingController cavvalue_crontroller =
      new TextEditingController();

  final TextEditingController cdkey_crontroller = new TextEditingController();
  final TextEditingController cdvalue_crontroller = new TextEditingController();

  final TextEditingController cmkey_crontroller = new TextEditingController();
  final TextEditingController cmvalue_crontroller = new TextEditingController();

  @override
  Widget build(BuildContext context) {
    return FocusMonitoring(
      child: Scaffold(
        appBar: AppBar(title: const Text('input Test')),
        body: SingleChildScrollView(
          padding: EdgeInsets.all(16.0),
          child: Column(
            children: [
              const Center(child: Text('Trigger an action:\n')),
              TextField(
                controller: dt_crontroller,
                decoration: new InputDecoration(
                  hintText: "页面事件标题-dt",
                ),
              ),
              TextField(
                controller: ec_crontroller,
                decoration: new InputDecoration(
                  hintText: "基础事件-eventClassify",
                ),
              ),
              TextField(
                controller: ea_crontroller,
                decoration: new InputDecoration(
                  hintText: "基础事件-eventAction",
                ),
              ),
              TextField(
                controller: et_crontroller,
                decoration: new InputDecoration(
                  hintText: "基础事件-eventTag",
                ),
              ),
              TextField(
                controller: ep_crontroller,
                decoration: new InputDecoration(
                  hintText: "基础事件-eventPrice",
                ),
              ),
              TextField(
                controller: caid_crontroller,
                decoration: new InputDecoration(
                  hintText: "高级事件caid",
                ),
              ),
              TextField(
                controller: calkey_crontroller,
                decoration: new InputDecoration(
                  hintText: "高级事件cal-key",
                ),
              ),
              TextField(
                controller: calvalue_crontroller,
                decoration: new InputDecoration(
                  hintText: "高级事件cal-value",
                ),
              ),
              TextField(
                controller: cavkey_crontroller,
                decoration: new InputDecoration(
                  hintText: "高级事件cav-key",
                ),
              ),
              TextField(
                controller: cavvalue_crontroller,
                decoration: new InputDecoration(
                  hintText: "高级事件cav-value",
                ),
              ),
              TextField(
                controller: cdkey_crontroller,
                decoration: new InputDecoration(
                  hintText: "维度cd-key",
                ),
              ),
              TextField(
                controller: cdvalue_crontroller,
                decoration: new InputDecoration(
                  hintText: "维度cd-value",
                ),
              ),
              TextField(
                controller: cmkey_crontroller,
                decoration: new InputDecoration(
                  hintText: "维度cm-key",
                ),
              ),
              TextField(
                controller: cmvalue_crontroller,
                decoration: new InputDecoration(
                  hintText: "维度cm-value",
                ),
              ),
              Container(
                child: Row(
                  mainAxisAlignment: MainAxisAlignment.spaceEvenly, //元素与空白互相间隔
                  children: [
                    ElevatedButton(
                      key: Key("key5"),
                      onPressed: () {
                        MzanalyticsMybmw.appid("3852");
                      },
                      child: Text('激活'),
                    ),
                    ElevatedButton(
                      key: Key("key1"),
                      onPressed: () {
                        var dt = dt_crontroller.text;
                        var ec = ec_crontroller.text;
                        var ea = ea_crontroller.text;
                        var et = et_crontroller.text;
                        var ep = ep_crontroller.text;

                        var caid = caid_crontroller.text;
                        var calkey = calkey_crontroller.text;
                        var calvalue = calvalue_crontroller.text;
                        var cavkey = cavkey_crontroller.text;
                        var cavvalue = cavvalue_crontroller.text;

                        var cdkey = cdkey_crontroller.text;
                        var cdvalue = cdvalue_crontroller.text;
                        var cmkey = cmkey_crontroller.text;
                        var cmvalue = cmvalue_crontroller.text;

                        MzanalyticsMybmw.trackPageView({
                          "dt": dt,
                          "CustomDimMetrics": {
                            cdkey: cdvalue,
                            cmkey: cmvalue,
                          }
                        });
                      },
                      child: Text('页面'),
                    ),
                    ElevatedButton(
                      key: Key("key2"),
                      onPressed: () {
                        var dt = dt_crontroller.text;
                        var ec = ec_crontroller.text;
                        var ea = ea_crontroller.text;
                        var et = et_crontroller.text;
                        var ep = ep_crontroller.text;

                        var caid = caid_crontroller.text;
                        var calkey = calkey_crontroller.text;
                        var calvalue = calvalue_crontroller.text;
                        var cavkey = cavkey_crontroller.text;
                        var cavvalue = cavvalue_crontroller.text;

                        var cdkey = cdkey_crontroller.text;
                        var cdvalue = cdvalue_crontroller.text;
                        var cmkey = cmkey_crontroller.text;
                        var cmvalue = cmvalue_crontroller.text;
                        MzanalyticsMybmw.trackEvent({
                          "ec": ec,
                          "ea": ea,
                          "el": et,
                          "ev": ep,
                          "CustomDimMetrics": {cdkey: cdvalue, cmkey: cmvalue}
                        });
                      },
                      child: Text('基础'),
                    ),
                    ElevatedButton(
                      key: Key("key3"),
                      onPressed: () {
                        var dt = dt_crontroller.text;
                        var ec = ec_crontroller.text;
                        var ea = ea_crontroller.text;
                        var et = et_crontroller.text;
                        var ep = ep_crontroller.text;

                        var caid = caid_crontroller.text;
                        var calkey = calkey_crontroller.text;
                        var calvalue = calvalue_crontroller.text;
                        var cavkey = cavkey_crontroller.text;
                        var cavvalue = cavvalue_crontroller.text;

                        var cdkey = cdkey_crontroller.text;
                        var cdvalue = cdvalue_crontroller.text;
                        var cmkey = cmkey_crontroller.text;
                        var cmvalue = cmvalue_crontroller.text;
                        MzanalyticsMybmw.trackSiteCustomEvent({
                          "CustomEvent": {
                            "caid": caid,
                            calkey: calvalue,
                            cavkey: cavvalue,
                          },
                          "CustomDimMetrics": {
                            cdkey: cdvalue,
                            cmkey: cmvalue,
                          }
                        });
                      },
                      child: Text('高级'),
                    ),
                    ElevatedButton(
                      key: Key("key4"),
                      onPressed: () {
                        MzanalyticsMybmw.trackPulse();
                      },
                      child: Text('心跳'),
                    ),
                  ],
                ),
              ),
              Container(
                child: Row(
                  mainAxisAlignment: MainAxisAlignment.spaceAround, //元素与空白互相间隔
                  children: [
                    ElevatedButton(
                      key: Key("key6"),
                      onPressed: () {
                        String symbol =
                            "．.。/\\，,、；;：:？！ˉˇ¨`~ 々～‖∶＂\"＇'｀｜·… — ～ - 〃‘’“”〝〞〔〕〈〉<>《》「」『』〖〗【】（）()［］{}｛｝︻︼﹄﹃";
                        dt_crontroller.text = symbol;
                        ec_crontroller.text = symbol;
                        ea_crontroller.text = symbol;
                        et_crontroller.text = symbol;
                        ep_crontroller.text = "0";

                        caid_crontroller.text = "100";
                        calkey_crontroller.text = "cal1";
                        calvalue_crontroller.text = symbol;
                        cavkey_crontroller.text = "cav1";
                        cavvalue_crontroller.text = "77";

                        cdkey_crontroller.text = "cd1";
                        cdvalue_crontroller.text = symbol;
                        cmkey_crontroller.text = "cm1";
                        cmvalue_crontroller.text = "33";
                      },
                      child: Text('标点符号'),
                    ),
                    ElevatedButton(
                      key: Key("key7"),
                      onPressed: () {
                        String symbol =
                            "＋－×÷﹢﹣±／＝ ∥∠ ≌ ∽ ≦ ≧ ≒﹤﹥ ≈ ≡ ≠ ＝ ≤ ≥ ＜ ＞ ≮ ≯∷ ∶ ∫ ∮ ∝ ∞ ∧ ∨ ∑ ∏ ∪ ∩ ∈ ∵ ∴ ⊥ ∥ ∠ ⌒ ⊙ √∟⊿ ㏒ ㏑ ％ ‰㎎ ㎏ ㎜ ㎝ ㎞㎡㏄ ㏎ ㏑ ㏒ ㏕ ℡  ‰ ℃ ℉ °′″＄ ￡ ￥ ￠ ♂ ♀℅";
                        dt_crontroller.text = symbol;
                        ec_crontroller.text = symbol;
                        ea_crontroller.text = symbol;
                        et_crontroller.text = symbol;
                        ep_crontroller.text = "1";

                        caid_crontroller.text = "200";
                        calkey_crontroller.text = "cal1";
                        calvalue_crontroller.text = symbol;
                        cavkey_crontroller.text = "cav1";
                        cavvalue_crontroller.text = "88";

                        cdkey_crontroller.text = "cd1";
                        cdvalue_crontroller.text = symbol;
                        cmkey_crontroller.text = "cm1";
                        cmvalue_crontroller.text = "44";
                      },
                      child: Text('数学单位符号'),
                    ),
                    ElevatedButton(
                      key: Key("key8"),
                      onPressed: () {
                        String symbol =
                            "♧♡♂♀♠♣♥❤☜☞☎☏⊙◎ ☺☻☼▧▨♨◐◑↔↕▪ ? ◊◦▣▤▥ ▦▩◘ ◈◇♬♪♩♭♪の★☆→あぃ￡Ю〓§♤♥▶¤๑⊹⊱⋛⋌⋚⊰⊹";
                        dt_crontroller.text = symbol;
                        ec_crontroller.text = symbol;
                        ea_crontroller.text = symbol;
                        et_crontroller.text = symbol;
                        ep_crontroller.text = "2";
                        caid_crontroller.text = "300";
                        calkey_crontroller.text = "cal1";
                        calvalue_crontroller.text = symbol;
                        cavkey_crontroller.text = "cav1";
                        cavvalue_crontroller.text = "99";

                        cdkey_crontroller.text = "cd1";
                        cdvalue_crontroller.text = symbol;
                        cmkey_crontroller.text = "cm1";
                        cmvalue_crontroller.text = "55";
                      },
                      child: Text('表情符号'),
                    ),
                  ],
                ),
              ),
              Container(
                child: Row(
                  mainAxisAlignment: MainAxisAlignment.spaceAround, //元素与空白互相间隔
                  children: [
                    ElevatedButton(
                      key: Key("key6"),
                      onPressed: () {
                        String symbol =
                            "{\x22e\x22:{\x22@type\x22:\x22java.lang.Class\x22,\x22val\x22:\x22com.mchange.v2.c3p0.WrapperConnecti \x22,\ AsciiS 7574696C2E5072696F7269;\x22}}";
                        dt_crontroller.text = symbol;
                        ec_crontroller.text = symbol;
                        ea_crontroller.text = symbol;
                        et_crontroller.text = symbol;
                        ep_crontroller.text = "0";

                        caid_crontroller.text = "100";
                        calkey_crontroller.text = "cal1";
                        calvalue_crontroller.text = symbol;
                        cavkey_crontroller.text = "cav1";
                        cavvalue_crontroller.text = "77";

                        cdkey_crontroller.text = "cd1";
                        cdvalue_crontroller.text = symbol;
                        cmkey_crontroller.text = "cm1";
                        cmvalue_crontroller.text = "33";
                      },
                      child: Text('json测试'),
                    ),
                  ],
                ),
              ),
            ],
          ),
        ),
      ),
    );
  }
}
