//
//  MLTSiteManager.h
//  MLTSiteSDK
//
//  Created by 黄力 on 2019/7/24.
//  Copyright © 2019 MLT. All rights reserved.
//

#import <Foundation/Foundation.h>
NS_ASSUME_NONNULL_BEGIN

@interface MLTSiteManager : NSObject

/* 调试模式，输出日志
 默认为 NO
 */
+ (void)setEnableLog:(BOOL)isEnableLog;






+ (MLTSiteManager *)shareInstance;

//初始化
+ (MLTSiteManager *)sharedInstanceWithAppId:(NSString *)appId channel:(NSString *)channel;

/* 崩溃监测 （需先进行初始化SDK）
 默认 关闭
 */
+(void)enableExceptionService:(BOOL)enable;


/**获取访客id*/
+(NSString *)getCid;

/**设置caid及其相应版本号*/
+(void)setCAID:(NSString * __nonnull)currentCAID andCAIDVersion:(NSString* __nullable)currentCAIDVersion setLastCAID:(NSString * __nullable)lastCAID andLastCAIDVersion:(NSString * __nullable )lastCAIDVersion;



//进入页面
 
- (void)trackPageView:(NSString *)title appendCustomDimMetrics:(nullable NSDictionary *)customDimMetrics ;

//事件。事件分类，事件动作，事件标签，事件价值
- (void)trackEvent:(NSString *)eventClassify eventAction:(NSString *)eventAction eventTag:(nullable NSString *)eventTag eventPrice:(NSString *)eventPrice appendCustomDimMetrics:( nullable NSDictionary *)customDimMetrics;

//自定义高级事件
- (void)trackSiteCustomEvent:(NSDictionary *)customEvent appendCustomDimMetrics:( nullable NSDictionary *)customDimMetrics;
 

//心跳检测（关闭页面或返回桌面时调用）
-(void)trackPulse;

/**DeepLink和Universal Links*/
+(void)handleOpenURL:(NSURL *)url;

/**设置自定义的维度和指标*/
+(void)setCd:(NSString * )key forValue:(NSString*)value;
+(void)setCm:(NSString * )key forValue:(NSString*)value;
+(void)deleteCdForKey:(NSString * )key;
+(void)deleteCmForKey:(NSString * )key;

/**发送异常*/
- (void)trackException:(NSException *)exception;


/* 开启后台任务
   进入后台时调用
 */
- (void)beginBackgroudTask;

/* 取消后台任务
   进入前台时调用
 */
- (void)invalidBackgroundTask;

 


@end

NS_ASSUME_NONNULL_END
