//
//  MLT_SDKConfig.h
//  MobileTracking
//
//  Created by Wenqi on 14-3-11.
//  Copyright (c) 2014年 Admaster. All rights reserved.
//

#import <Foundation/Foundation.h>
/*--------------缓存队列设置--------------*/
@interface MLT_OfflineCache : NSObject

@property (nonatomic, assign) NSInteger length; // 发送队列长度，达到此队列长度时自动提交
@property (nonatomic, assign) NSInteger queueExpirationSecs; // 错误队列发送的重试时间间隔，单位为秒
@property (nonatomic, assign) NSInteger timeout; // 发送超时时间，单位为秒

@end
/*--------------事件、参数设置------------*/
@interface MLT_Config : NSObject

@property (nonatomic, assign) BOOL idfa;
@property (nonatomic, assign) BOOL autotrackpage;
@property (nonatomic, assign) NSInteger crashDelayTime;

@property (nonatomic, strong) NSArray * manualtrackpage;


@end
/*--------------参数设置-----------------*/
@interface MLT_Argument : NSObject

@property (nonatomic, strong) NSString *key;
@property (nonatomic, strong) NSString *value;
@property (nonatomic, assign) Boolean urlEncode;
@property (nonatomic, assign) Boolean isRequired;

@end
/*--------------事件设置-----------------*/
@interface MLT_Event : NSObject

@property (nonatomic, strong) NSString *key;
@property (nonatomic, strong) NSString *value;
@property (nonatomic, assign) Boolean urlEncode;

@end

/*--------------加密签名设置--------------*/
@interface MLT_Signature : NSObject

@property (nonatomic,strong) NSString * publicKey;
@property (nonatomic,strong) NSString * paramKey;

@end
/*--------------公司开关设置--------------*/
@interface MLT_Switch : NSObject
@property (nonatomic, assign) NSInteger viewabilityTrackPolicy;
@property (nonatomic, assign) Boolean isTrackLocation;
@property (nonatomic, assign) NSInteger offlineCacheExpiration;
@property (nonatomic, strong) NSMutableDictionary *encrypt;

@end
/*--------------公司信息-----------------*/
@interface MLT_Company : NSObject

@property (nonatomic, strong) NSString *name;
@property (nonatomic, strong) NSMutableArray *domain;
@property (nonatomic, strong) MLT_Signature *signature;
@property (nonatomic, strong) MLT_Switch *MLTSwitch;
@property (nonatomic, strong) MLT_Config *config ;
@property (nonatomic, strong) NSString *separator;
@property (nonatomic, strong) NSString *equalizer;
@property (nonatomic, strong) NSString *antidevice;
@property (nonatomic, assign) Boolean timeStampUseSecond;
@property (nonatomic, strong) NSString *jsname;
@property (nonatomic, strong) NSString *jsurl;


@end
/*--------------配置文件信息--------------*/
@interface MLT_SDKConfig : NSObject

@property(strong, nonatomic) MLT_OfflineCache *offlineCache; // 缓存队列设置
@property(strong, nonatomic) MLT_Config *SDKConfig; // 缓存队列设置
@property(strong, nonatomic) NSMutableDictionary *companies; // <MLT_Company> 公司的配置信息

@end
